<html>
<head>
<title>OgreShadowCaster.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShadowCaster.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShadowCaster_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __ShadowCaster_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __ShadowCaster_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00052"></a><a class="code" href="classOgre_1_1ShadowRenderable.html">00052</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ShadowDataAlloc</a>
<a name="l00053"></a>00053     {
<a name="l00054"></a>00054     <span class="keyword">protected</span>:
<a name="l00055"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#a8c86d49c8c295f71ee409d1b20e5854d">00055</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1ShadowRenderable.html#a8c86d49c8c295f71ee409d1b20e5854d">mMaterial</a>;
<a name="l00056"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#aa88e6ce3da25b3ea5a2fc5e622798b37">00056</a>         <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> <a class="code" href="classOgre_1_1ShadowRenderable.html#aa88e6ce3da25b3ea5a2fc5e622798b37">mRenderOp</a>;
<a name="l00057"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#ac5e870a708a1fcc9fa8d6873aa11f5c1">00057</a>         <a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a>* <a class="code" href="classOgre_1_1ShadowRenderable.html#ac5e870a708a1fcc9fa8d6873aa11f5c1">mLightCap</a>; <span class="comment">// used only if isLightCapSeparate == true</span>
<a name="l00058"></a>00058     <span class="keyword">public</span>:
<a name="l00059"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#afd48548fe3314d5d419c695c0788b278">00059</a>         <a class="code" href="classOgre_1_1ShadowRenderable.html#afd48548fe3314d5d419c695c0788b278">ShadowRenderable</a>() : mMaterial(), mLightCap(0) {}
<a name="l00060"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#a3b9d5d4abdc4158e035c174816748305">00060</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ShadowRenderable.html#a3b9d5d4abdc4158e035c174816748305">~ShadowRenderable</a>() { <span class="keyword">delete</span> mLightCap; }
<a name="l00064"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#a624c5d9e88df9caeb2f7d57e69dab2be">00064</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ShadowRenderable.html#a624c5d9e88df9caeb2f7d57e69dab2be" title="Set the material to be used by the shadow, should be set by the caller before adding to a render queu...">setMaterial</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat) { mMaterial = mat; }
<a name="l00066"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#af314cc202a2b7c3dcf4dd3dc9432346e">00066</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; <a class="code" href="classOgre_1_1ShadowRenderable.html#af314cc202a2b7c3dcf4dd3dc9432346e" title="Overridden from Renderable.">getMaterial</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaterial; }
<a name="l00068"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#a36d3d1a31ec2661d66faa4675391ed25">00068</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ShadowRenderable.html#a36d3d1a31ec2661d66faa4675391ed25" title="Overridden from Renderable.">getRenderOperation</a>(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op) { op = mRenderOp; }
<a name="l00070"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#ae192ff33315f05bee1865a64547fe9a2">00070</a>         <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>* <a class="code" href="classOgre_1_1ShadowRenderable.html#ae192ff33315f05bee1865a64547fe9a2" title="Get the internal render operation for set up.">getRenderOperationForUpdate</a>(<span class="keywordtype">void</span>) {<span class="keywordflow">return</span> &amp;mRenderOp;}
<a name="l00072"></a>00072         <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span> = 0;
<a name="l00074"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#a0095fe3c8590580bb2b2176e5f279615">00074</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1ShadowRenderable.html#a0095fe3c8590580bb2b2176e5f279615" title="Overridden from Renderable.">getSquaredViewDepth</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>*)<span class="keyword"> const</span>{ <span class="keywordflow">return</span> 0; <span class="comment">/* not used */</span>}
<a name="l00076"></a>00076         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00087"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#a46225aeba80348f0a48b73fb1667866d">00087</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ShadowRenderable.html#a46225aeba80348f0a48b73fb1667866d" title="Does this renderable require a separate light cap?">isLightCapSeparate</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLightCap != 0; }
<a name="l00088"></a>00088 
<a name="l00090"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#a9039657d8484c4c1d5bc249aa4bce723">00090</a>         <a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a>* <a class="code" href="classOgre_1_1ShadowRenderable.html#a9039657d8484c4c1d5bc249aa4bce723" title="Get the light cap version of this renderable.">getLightCapRenderable</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mLightCap; }
<a name="l00092"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#ae3bb22e06004a85619a71255367dd72f">00092</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ShadowRenderable.html#ae3bb22e06004a85619a71255367dd72f" title="Should this ShadowRenderable be treated as visible?">isVisible</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00093"></a>00093 
<a name="l00099"></a>00099         <span class="keyword">virtual</span> <span class="keywordtype">void</span> rebindIndexBuffer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>&amp; indexBuffer) = 0;
<a name="l00100"></a>00100 
<a name="l00101"></a>00101     };
<a name="l00102"></a>00102 
<a name="l00104"></a><a class="code" href="group__Scene.html#ga5422f3d75ddc606ee01f69d14e37a8cc">00104</a>     <span class="keyword">enum</span> <a class="code" href="group__Scene.html#ga5422f3d75ddc606ee01f69d14e37a8cc" title="A set of flags that can be used to influence ShadowRenderable creation.">ShadowRenderableFlags</a>
<a name="l00105"></a>00105     {
<a name="l00107"></a><a class="code" href="group__Scene.html#gga5422f3d75ddc606ee01f69d14e37a8cca42b7242b2403601a94289579c0484b7e">00107</a>         <a class="code" href="group__Scene.html#gga5422f3d75ddc606ee01f69d14e37a8cca42b7242b2403601a94289579c0484b7e" title="For shadow volume techniques only, generate a light cap on the volume.">SRF_INCLUDE_LIGHT_CAP</a> = 0x00000001,
<a name="l00109"></a><a class="code" href="group__Scene.html#gga5422f3d75ddc606ee01f69d14e37a8cca33f01b987b6a184a90c99533cc257992">00109</a>         <a class="code" href="group__Scene.html#gga5422f3d75ddc606ee01f69d14e37a8cca33f01b987b6a184a90c99533cc257992" title="For shadow volume techniques only, generate a dark cap on the volume.">SRF_INCLUDE_DARK_CAP</a>  = 0x00000002,
<a name="l00111"></a><a class="code" href="group__Scene.html#gga5422f3d75ddc606ee01f69d14e37a8ccacb424293924baf3e1b2bb29041270fec">00111</a>         <a class="code" href="group__Scene.html#gga5422f3d75ddc606ee01f69d14e37a8ccacb424293924baf3e1b2bb29041270fec" title="For shadow volume techniques only, indicates volume is extruded to infinity.">SRF_EXTRUDE_TO_INFINITY</a>  = 0x00000004
<a name="l00112"></a>00112     };
<a name="l00113"></a>00113 
<a name="l00116"></a><a class="code" href="classOgre_1_1ShadowCaster.html">00116</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ShadowCaster.html" title="This class defines the interface that must be implemented by shadow casters.">ShadowCaster</a>
<a name="l00117"></a>00117     {
<a name="l00118"></a>00118     <span class="keyword">public</span>:
<a name="l00119"></a><a class="code" href="classOgre_1_1ShadowCaster.html#aa09c6e22f9879c123355bca19c1b7131">00119</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ShadowCaster.html#aa09c6e22f9879c123355bca19c1b7131">~ShadowCaster</a>() { }
<a name="l00121"></a>00121         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getCastShadows(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00122"></a>00122 
<a name="l00124"></a>00124         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* getEdgeList(<span class="keywordtype">void</span>) = 0;
<a name="l00126"></a>00126         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasEdgeList(<span class="keywordtype">void</span>) = 0;
<a name="l00127"></a>00127 
<a name="l00129"></a>00129         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getWorldBoundingBox(<span class="keywordtype">bool</span> derive = <span class="keyword">false</span>) <span class="keyword">const</span> = 0;
<a name="l00131"></a>00131         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getLightCapBounds(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00133"></a>00133         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getDarkCapBounds(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>&amp; light, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dirLightExtrusionDist) <span class="keyword">const</span> = 0;
<a name="l00134"></a>00134 
<a name="l00135"></a><a class="code" href="classOgre_1_1ShadowCaster.html#ad84ea1b2728ced5136add26c91c39a27">00135</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ShadowRenderable*&gt;::type</a> <a class="code" href="classOgre_1_1ShadowCaster.html#ad84ea1b2728ced5136add26c91c39a27">ShadowRenderableList</a>;
<a name="l00136"></a><a class="code" href="classOgre_1_1ShadowCaster.html#a7b0999d33e25db97d0449d6cf95cbecd">00136</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;ShadowRenderableList&gt;</a> <a class="code" href="classOgre_1_1ShadowCaster.html#a7b0999d33e25db97d0449d6cf95cbecd">ShadowRenderableListIterator</a>;
<a name="l00137"></a>00137 
<a name="l00153"></a>00153         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">ShadowRenderableListIterator</a> getShadowVolumeRenderableIterator(
<a name="l00154"></a>00154             <a class="code" href="group__General.html#ga79dcd426d291c31072c1ad6f183715d6" title="An enumeration of broad shadow techniques.">ShadowTechnique</a> shadowTechnique, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light, 
<a name="l00155"></a>00155             <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>* indexBuffer, 
<a name="l00156"></a>00156             <span class="keywordtype">bool</span> extrudeVertices, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrusionDistance, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags = 0 ) = 0;
<a name="l00157"></a>00157 
<a name="l00177"></a>00177         <span class="keyword">static</span> <span class="keywordtype">void</span> extrudeVertices(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; vertexBuffer, 
<a name="l00178"></a>00178             <span class="keywordtype">size_t</span> originalVertexCount, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; lightPos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrudeDist);
<a name="l00180"></a>00180         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPointExtrusionDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* l) <span class="keyword">const</span> = 0;
<a name="l00181"></a>00181     <span class="keyword">protected</span>:
<a name="l00183"></a>00183         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getExtrusionDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; objectPos, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light) <span class="keyword">const</span>;
<a name="l00191"></a>00191         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateEdgeListLightFacing(<a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* edgeData, 
<a name="l00192"></a>00192             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; lightPos);
<a name="l00193"></a>00193 
<a name="l00207"></a>00207         <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateShadowVolume(<a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* edgeData, 
<a name="l00208"></a>00208             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>&amp; indexBuffer, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light,
<a name="l00209"></a>00209             <a class="code" href="classOgre_1_1ShadowCaster.html#ad84ea1b2728ced5136add26c91c39a27">ShadowRenderableList</a>&amp; shadowRenderables, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);
<a name="l00216"></a>00216         <span class="keyword">virtual</span> <span class="keywordtype">void</span> extrudeBounds(<a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; lightPos, 
<a name="l00217"></a>00217             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrudeDist) <span class="keyword">const</span>;
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220     };
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
